import java.net.*;
import java.io.*;
import java.util.*;

public class HttpClientHttpURLConnection {
    public static void main(String[] args)
        throws MalformedURLException, ProtocolException, IOException {

        URL url = new URL("http://www.yahoo.co.jp/");

        HttpURLConnection urlconn = (HttpURLConnection)url.openConnection();
        urlconn.setRequestMethod("GET");
        urlconn.setInstanceFollowRedirects(false);
        urlconn.setRequestProperty("Accept-Language", "ja;q=0.7,en;q=0.3");

        urlconn.connect();

        Map headers = urlconn.getHeaderFields();
        Iterator it = headers.keySet().iterator();
        System.out.println("0");
        while (it.hasNext()){
            String key= (String)it.next();
//			String hoge = headers.get(key) ;
            System.out.println("  " + key + ": " + headers.get(key));
        }
		String key = "Content-Length" ;
            System.out.println("  " + key + ": " + headers.get(key));


        System.out.println("[" + urlconn.getResponseCode() + "] \n" +
                           "[" + urlconn.getResponseMessage() + "]");

        BufferedReader reader =
            new BufferedReader(new InputStreamReader(urlconn.getInputStream()));

        while (true){
            String line = reader.readLine();
            if ( line == null ){
                break;
            }
//            System.out.println(line);
        }

        reader.close();
        urlconn.disconnect();
    }
}
