import java.net.URL;
import java.net.URLConnection;
import java.io.IOException;
import java.io.RandomAccessFile;
import java.io.BufferedInputStream;
import java.io.FileInputStream;
import java.io.File;
import java.net.*;
import java.io.*;
import java.util.*;


public class DownLoader {
    
    private String URLAddress ; 
    private URLConnection connection ;
    private long fullsize = 0 ;
	private long nowsize  = 0 ;
	private HttpURLConnection urlconn ;
	private boolean isCnct = false ;
	private String error ;
	private String savefile ; 
	OmatomekunGUI og ;
    
    public DownLoader(String e, OmatomekunGUI f) {
		this.URLAddress = e ;
		this.og = f ;
    }

    public int setURL(String e) {
		this.URLAddress = e ;
		return 0 ;
    }
	
	public int setSavefile(String e) {
		this.savefile = e ;
		return 0 ;
    }
    
    public long getFileSize(){
		cnct() ;
		if(this.isCnct = false){ this.fullsize=0 ; return -1 ; }
		Map headers = this.urlconn.getHeaderFields();
		String key = "Content-Length" ;
//		System.out.println(headers.get(key));
		try{
			String e = (headers.get(key)).toString();
			e = e.substring(1,e.length()-1) ;
			this.fullsize = Long.parseLong(e) ;}
		catch(Exception f){
			System.out.println("t@CTCY擾s 404? "+f) ;
			this.error = this.error + f ;
		}
		discnct() ;
		if(this.fullsize < 0) return -1 ;
		else return this.fullsize ;
    }
    
	
	private boolean cnct() {
		try{
			URL url = new URL(this.URLAddress);
			this.urlconn = (HttpURLConnection)url.openConnection();
			this.urlconn.setRequestMethod("GET");
			this.urlconn.setInstanceFollowRedirects(false);
			this.urlconn.setRequestProperty("Accept-Language", "ja;q=0.7,en;q=0.3");
			this.urlconn.connect();
			this.isCnct = true ;
			
/*			Map headers = urlconn.getHeaderFields();
			Iterator it = headers.keySet().iterator();
			System.out.println("0");
			while (it.hasNext()){
				String key= (String)it.next();
				System.out.println("  " + key + ": " + headers.get(key));
			}
*/
			return true ;
		}
		catch(Exception e){
			System.out.println("RlNgs:(cnct)"+e) ;
			this.error = this.error + e ;
			this.isCnct = false ;
			return false ;
		}
	}
	
	private boolean discnct() {
		if(isCnct = true){
			try{
				this.urlconn.disconnect();
				this.isCnct = false ;
				return false ;
			}
			catch(Exception e){
				System.out.println("fBXRlNgs:(cnct)"+e) ;
				this.error = this.error + e ;
				this.isCnct = true ;
				return true ;
			}
		}
		else{
				System.out.println("fBXRlNgs:(cnct)") ;
				isCnct = false ;
				return false ;
		}
	}
	        
    
    
    public void download() {
		long buffersize = 256*256 ;
		long maxroop = 0 ;
		if(this.fullsize > 0  ) maxroop = (this.fullsize / buffersize) + 1;
		else                    maxroop = (getFileSize() / buffersize) + 1;
		if(maxroop < 1) {
			System.out.println("_E[hs 404? ") ;
			return ;
		}
		long i=0;
		float length ;
		
		try{
			RandomAccessFile file = new RandomAccessFile( new File(this.savefile), "rw");
			if(this.URLAddress == null) return ;
			cnct();
                
			BufferedInputStream bis = new BufferedInputStream(urlconn.getInputStream());
			file.seek(file.length());
			
			byte[] buf = new byte[(int)buffersize] ;
			
			
			while((length = bis.read(buf, 0, (int)buffersize)) !=-1){
                    file.write(buf,0,(int)length);
					og.setString("_E[hF" + (buffersize*i/fullsize) + "" ) ;
					System.out.println("_E[hF" + (buffersize*i*2.15631288)/fullsize + "" ) ;
					i++;
					
					
			}
			og.setString(" >> "+savefile) ;
			System.out.println("t@C݊ >> "+savefile) ;
			discnct() ;
		}
		catch(FileNotFoundException e){
			System.out.println("_E[hs or t@Cݎs"+e) ;
			this.error = this.error + e ;
			return ;
		}
		catch(Exception e){
			System.out.println("t@Cݎs"+e) ;
			this.error = this.error + e ;
			return ;
		}
    }
	
	public static void main(String args[]) {
//		DownLoader e ;
//		e = new DownLoader("http://aurorae.s14.xrea.com/omatomekun/binary/23/omatome.zip") ;
//		System.out.println(e.getFileSize()) ;
//		e.setSavefile("hoge.zip") ;
//		e.download() ;
	}
    
}